/***************************************************************\

* File:          Hangar.h
* Creation date: January 12, 2005 19:57
* Author:        jpc
*                XXXX
* Purpose:       Declaration of class 'Hangar'
\******************************************************************/
#ifndef _HANGAR_H
#define _HANGAR_H

template <typename T, class A> class Hangar{
public:
		typedef typename A::pointer iterateur;



	private:
		A alloc;
		iterateur debut;//premier element
		iterateur fin;  // juste aprs le dernier element prsent
		iterateur max;  // pointe aprs la dernire place alloue a Hangar
		int nb_element; // nombre element contenu
		int nbPlace;	//capacit du Hangar;


private:
/*
Method which must be called second in a constructor.
*/
void ConstructorInclude(unsigned int nbr, const T& val){
	for(iterateur i=debut;i<max;i++) alloc.construct(i,val);
}

/*
Method which must be called first in a destructor.
*/
void DestructorInclude(int n)
{
	alloc.deallocate(debut,n);
}

public:

//CONSTRUCTEURS
Hangar(int n, const T& val= T(), const A& a=A())
:alloc(a),nb_element(0),nbPlace(n){
			debut=alloc.allocate(n,0);
			fin=debut;
			max=debut+n;
			ConstructorInclude(n,val);
}

//DESTRUCTEUR
~Hangar(){
    DestructorInclude(nbPlace);
}

//METHODES
	
iterateur premier() const {
		return debut;}

iterateur dernier() const {
		return fin;}

iterateur maxi() const {
		return max;}

bool vide(){
	return (nb_element==0);}

bool plein(){
	return nb_element==nbPlace ;
}

int capacity(){
	return nbPlace;}


void affiche ( ostream& o){
				if (vide()==false)
				for (iterateur p=debut;p<fin;p++)
					p->affiche (o) ;
				else o <<"liste vide"<<endl;
				}

void AddT( T &V){
    assert(this);
	V._refHangar =  this;
	*fin=V;
	fin++;
	nb_element++;
}

void RemoveT(T& pT){
	assert(this);
	iterateur index=recherche(pT);
	pT._refHangar=  0;
	for(iterateur j=index;j<fin-1;j++) *j=*(j+1);
	//l'objet a disparu du hangar
	nb_element--;
	fin--;
}

//SURCHARGE oprateur
T& operator [](unsigned int index){
    T& value;
    value= (debut+ index);
    return value;
}

//private:
public:
iterateur  recherche( T&  pT){
	iterateur index = 0;
	for(iterateur i=debut;i<fin;i++) if (*i == pT){index =i;break;}
	
	return index;
}

};

#endif
