/***************************************************************\

* File:          Hangar.h
* Creation date: January 12, 2005 19:57
* Author:        jpc
*                XXXX
* Purpose:       Declaration of class 'Hangar'
\******************************************************************/
#ifndef _HANGAR_H
#define _HANGAR_H

template<class T>
class Hangar
{

private:
    void ConstructorInclude(unsigned int nbr);
    void DestructorInclude();

private:
    T** pTab;
    int debut;
    int fin;
    int nbPlace;

public:
//CONSTRUCTEURS
    Hangar(unsigned int debut_, unsigned int fin_, unsigned int nbr_);
    Hangar(unsigned int nbr_=5);
//DESTRUCTEUR
    virtual ~Hangar();
//METHODES
    void AddT(T* pT);
	void RemoveT(T* pT);
	void affiche(ostream & aff);
	const unsigned int dernier();
	bool plein();
//SURCHARGE oprateur
    T* operator [](unsigned int index);

//private:
public:
int recherche( T * pT);

//AMITIE
//friend  class Vehicule;
};

#endif


#ifdef CB_INLINES
#ifndef _HANGAR_H_INLINES
#define _HANGAR_H_INLINES



/*
Method which must be called second in a constructor.
*/
template<class T>
void Hangar<T>::ConstructorInclude(unsigned int nbr){
	for(int i=debut;i<nbr;i++) pTab[i]=(T*)0;
}

/*
Method which must be called first in a destructor.
*/
template<class T>
void Hangar<T>::DestructorInclude()
{
	for(int i=debut;i<fin;i++) if (pTab[i]) delete pTab[i];
}


/*
Constructor method.
*/
template<class T>
Hangar<T>::Hangar(unsigned int debut_, unsigned int fin_,unsigned int nbr_ ) 
    : debut(debut_)
    , fin(fin_)
    , nbPlace(nbr_){
	pTab=new T*[nbr];
    ConstructorInclude(nbr_);

}

/*
Constructor method.
*/
template<class T>
Hangar<T>::Hangar(unsigned int nbr_) 
    : debut(0)
    , fin(0)
    , nbPlace(nbr_){
	pTab=new T*[nbr_];
    ConstructorInclude(nbr_);
}



/*
Destructor method.
*/
template<class T>
Hangar<T>::~Hangar(){
    DestructorInclude();
}

//METHODES
template<class T>
void Hangar<T>::AddT(T* pT){
    assert(this);
    assert(pTab[fin] == (T*)0);
    assert(pT);
	pTab[fin++]=pT;
	pT->_refHangar =  this;
}

template<class T>
const unsigned int Hangar<T>::dernier(){   
    return fin;
}

template<class T>
T* Hangar<T>::operator [](unsigned int index){
    T* value;
    value= pTab[index];
    return value;
}

template<class T>
void Hangar<T>::affiche(ostream & aff){
	aff<<"contenu du hangar:"<<endl;
	for(int i=debut;i<fin;i++){
		assert(pTab[i]);
		pTab[i]->affiche(aff);
	}
}

template<class T>
bool Hangar<T>::plein(){return (fin==nbPlace);}

template<class T>
int Hangar<T>::recherche( T * pT){
	int index=-1;
	for(int i=debut;i<fin;i++) if (pT == pTab[i]){index =i;break;}
	
	return index;
}

template<class T>
void Hangar<T>::RemoveT(T* pT){
	assert(this);
	assert(pT);
	int index=recherche(pT);
	assert (index >=0);
	for(int j=index;j<fin-1;j++)pTab[j]=pTab[j+1];
	pTab[fin]=(T*)0;
	fin--;
}


#endif
#endif
