/******************************************************************************\
*
* File:          Personne1.cpp
* Creation date: December 14, 2004 10:03
* Author:        ClassBuilder
*                XXXX
* Purpose:       Method implementations of class 'Personne'
*

*
\******************************************************************************/

// Master include file
#include "PersMod1.h"

Personne::Personne(string nom_, string prenom_, int age_) 
    : nom(nom_)
    , prenom(prenom_)
    , age(age_){
    ConstructorInclude();
}

//DESTRUCTEUR
Personne::~Personne()
{
    DestructorInclude();  
}


void Personne::affiche(ostream& aff){
aff<<"PERSONNE\n";
aff<<"nom:"<<nom<<endl;
aff<<"prenom:"<<prenom<<endl;
aff<<"age:"<<age<<endl;
}

bool Personne::operator ==(Personne* pPersonne){
    bool value;
    
    value= (this->nom==pPersonne->nom)&&(this->prenom==pPersonne->prenom);
    
    return value;
}


//METHODE  appeler en premier dans le constructeur
void Personne::ConstructorInclude(){
		 _refVehicule = (Vehicule*)0;
}

//METHODE  appeler en premier dans le destructeur
void Personne::DestructorInclude(){
	    if (_refVehicule)
        delete _refVehicule;
}


//METHODES relation OBJET ACTIF->OBJET PASSIF

void Personne::AddVehicule(Vehicule* pVehicule){
    assert(this);
    assert(_refVehicule == (Vehicule*)0);
    assert(pVehicule);
    assert(pVehicule->_refPersonne == (Personne*)0);

    pVehicule->_refPersonne = this;
    _refVehicule = pVehicule;
}

void Personne::RemoveVehicule(Vehicule* pVehicule){
	assert(this);
    assert(_refVehicule == pVehicule);
    assert(pVehicule);
    assert(pVehicule->_refPersonne == this);

    pVehicule->_refPersonne = (Personne*)0;
    _refVehicule = (Vehicule*)0;
}

void Personne::ReplaceVehicule(Vehicule* pVehicule, Vehicule* pVehiculeNew){
    assert(this);
    assert(_refVehicule == pVehicule);
    assert(pVehicule);
    assert(pVehicule->_refPersonne == this);
    assert(pVehiculeNew);
    assert(pVehiculeNew->_refPersonne == (Personne*)0);

    pVehicule->_refPersonne = (Personne*)0;
    pVehiculeNew->_refPersonne = this;
    _refVehicule = pVehiculeNew;
}

void Personne::MoveVehicule(Vehicule* pVehicule){
    assert(this);
    assert(pVehicule);
    assert(pVehicule->_refPersonne);
	pVehicule->_refPersonne->RemoveVehicule(pVehicule);
    AddVehicule(pVehicule);
}


