/***************************************************************\
*
* File:          Personne1.h
* Creation date: December 14, 2004 10:03
* Author:        JPC
*                XXXX
* Purpose:       Declaration of class 'Personne'
\***************************************************************/
#ifndef _PERSONNE_H
#define _PERSONNE_H

class Personne{

private:
    string nom;
    string prenom;
    int age;

public:
//CONSTRUCTEURS
    Personne(string nom_, string prenom_, int age_);
//DESTRUCTEURS
    virtual ~Personne();
//METHODES
    void affiche(ostream& aff);
    bool operator ==(Personne* pPersonne);
//ACCESSEURS
    const int GetAge() const;
    void SetAge(int age);
    const string& GetNom() const;
    void SetNom(string& nom);
    const string& GetPrenom() const;
    void SetPrenom(string& prenom);

//Personne== OBJET ACTIF

public:
    //LIEN POUR RELATION SIMPLE vers objet passif
    Vehicule * _refVehicule;
//METHODES POUR RELATION SIMPLE avec objet passif
    void AddVehicule(Vehicule* pVehicule);
    void RemoveVehicule(Vehicule* pVehicule);
    void ReplaceVehicule(Vehicule* pVehicule, Vehicule* pVehiculeNew);

public:
    void MoveVehicule(Vehicule* pVehicule);
    Vehicule* GetVehicule() const {assert (this);return _refVehicule;};
    
    //METHODES POUR CONSTRUCTEURS ET DESTRUCTEURS
private:
    void ConstructorInclude();
    void DestructorInclude();

};

#endif

#ifdef CB_INLINES
#ifndef _PERSONNE_H_INLINES
#define _PERSONNE_H_INLINES


inline const int Personne::GetAge() const{
    return age;
}

inline void Personne::SetAge(int age){
    age = age;
}

inline const string& Personne::GetNom() const{
    return nom;
}

inline void Personne::SetNom(string& nom)
{
    nom = nom;
}

inline const string& Personne::GetPrenom() const{
    return prenom;
}

inline void Personne::SetPrenom(string& prenom){
    prenom = prenom;
}

#endif
#endif
