/******************************************************************************\
*
* File:          TabReg.h
* Creation date: May 18, 2005 12:03
* Author:        ClassBuilder
*                XXXX
* Purpose:       Declaration of class 'TabReg<T>'

\******************************************************************************/
#ifndef _TABREG_H
#define _TABREG_H
#include "Imagette.h"
#include "Region.h"
#include <utility>
#include<vector>
#include<set>
#include <algorithm>

typedef set<int> SET_INT;

class TabReg{
private:
    Imagette *pImag;
    //void DestructorInclude();

vector<Region> tab;
vector<Region> tabRtemp;
vector<SET_INT> tabAdj;

vector<Region>::iterator pts1,pts2,ptd1,ptd2;
vector<SET_INT>::iterator ptAdj;
SET_INT::iterator ptSet;


//METHODES
public:

    TabReg(Imagette *pt);
    virtual ~TabReg();
    vector<Region>& GetTab();
	vector<SET_INT>& GetTabAdj();

	void affAdj(ostream& aff);

	void CalculAttribut();
	void ConstructAdj();
	void ConstructGraph();

	int fusionReg(int seuil);


private:
	void ConstructorInclude();


};


TabReg::TabReg(Imagette * pt){
    //tab(pImag->GetNReg());
    //pImag=pt;
	pImag=new Imagette(*pt);
    tab.resize(pImag->GetNReg()+1);
	tabRtemp.resize(pImag->GetNReg()+1);
	tabAdj.resize(pImag->GetNReg()+1);
    ConstructorInclude();
    }
TabReg::~TabReg(){}


void TabReg::ConstructorInclude()
{
vector<Region>::iterator ptReg;
int i=0;
for (ptReg=tab.begin();ptReg!=tab.end();ptReg++){
    ptReg->SetLabel(i++);
    }
    //CalculAttribut();
	//ConstructAdj();
  }

vector<Region>& TabReg::GetTab(){
    return tab;
    }

vector<SET_INT>& TabReg::GetTabAdj(){
    return tabAdj;
    }

ostream& operator<<(ostream& aff, TabReg& Vreg){
    vector<Region>::iterator ptReg;
    //int i=1;
    for (ptReg=Vreg.GetTab().begin();ptReg!=Vreg.GetTab().end();ptReg++){
        aff<<"num:"<< ptReg->GetLabel()<<" , surf:"<<ptReg->GetSurface() <<endl;
    }
    return aff;
    }

void TabReg::CalculAttribut(){
    int index=0;
    for (int iy=0;iy<pImag->GetNY();iy++)
        for (int ix=0;ix<pImag->GetNX();ix++){

            index=pImag->GetPix(iy,ix);
            //cout<<"iy:"<<iy<<" ix:"<<ix<<" ->"<<index<<endl;
            tab[index].SetSurface(tab[index].GetSurface()+1);

            }
    }

void TabReg::ConstructAdj(){
int index=0;
int indexB=0;
int indexD=0;
int ixp1=0,iyp1=0;
for (int iy=0;iy<pImag->GetNY();iy++){
		iyp1=iy+1;
		if (iy==pImag->GetNY()-1) iyp1=iy;
		for (int ix=0;ix<pImag->GetNX();ix++){
			index=pImag->GetPix(iy,ix);

			ixp1=ix+1;
			if (ix==pImag->GetNX()-1) ixp1=ix;
			indexB=pImag->GetPix(iyp1,ix);
			indexD=pImag->GetPix(iy,ixp1);

			if (index!=indexB) {
				tabAdj[index].insert(indexB);
				tabAdj[indexB].insert(index);
			}
			if (index!=indexD) {
				tabAdj[index].insert(indexD);
				tabAdj[indexD].insert(index);
			}
		}
	}


}

void TabReg::ConstructGraph(){
    CalculAttribut();
	ConstructAdj();
}

int TabReg::fusionReg(int seuil){

	int nbfus=0;
	int nRegSupress;
	int surfMax=seuil;//pour que la region voisine avec laquelle on fusionne
	//ne soit pas une region  fusionner
	int numeroMax;
	//vector<Region>::iterator pts1,pts2,ptd1,ptd2;
	SET_INT::iterator ptAdj,ptMax,ptIci;

	partial_sort_copy(tab.begin(),tab.end(),tabRtemp.begin(),tabRtemp.end());
	//calcul du nombre de region a fusionner
	for (int k=1;k<=pImag->GetNReg();k++)
		if (tabRtemp[k].GetSurface()<=seuil) nbfus++;
	//boucle de fusion region par region
	for (int j=1;j<=nbfus;j++){
		nRegSupress=tabRtemp[j].GetLabel();//label region a fusionner
		cout<<"nRegSupress:"<<nRegSupress<<endl;
		//recherche de la region voisine de la region a fusionner 
		//ayant la plus grande surface
	
		//2006:il faut vrifier SI la plus grande des rgions est dans la liste
		//des rgions  fusionner!!! SI OUI non trait ici
	
		for (ptAdj=tabAdj[nRegSupress].begin(); ptAdj!=tabAdj[nRegSupress].end();ptAdj++){
			if (tab[*ptAdj].GetSurface()>surfMax) {
				//memorisation surface
				surfMax=tab[*ptAdj].GetSurface();
				//memorisation label region max surface
				numeroMax=tab[*ptAdj].GetLabel();
                //ptMax=ptAdj;
			}
        }//fin boucle maximum
		if (numeroMax)
		{//fusion si la region voisine > seuil
            //retire nRegSupress de Adj[numeroMax]
            tabAdj[numeroMax].erase(nRegSupress);
            //retire numeroMax de Adj[nRegSupress]
            tabAdj[nRegSupress].erase(numeroMax);
            //il faut supprimer NregSuppres dans toutes les lisTAdja de sa liste 
            //et le remplacer par numeroMax
            for (ptIci=tabAdj[nRegSupress].begin(); ptIci!=tabAdj[nRegSupress].end();ptIci++){
            tabAdj[*ptIci].erase(nRegSupress);
            tabAdj[*ptIci].insert(numeroMax);
            }
            //fusion Adj[numeroMax] avec Adj[nRegSupress]
            
            for (ptAdj=tabAdj[nRegSupress].begin(); ptAdj!=tabAdj[nRegSupress].end();ptAdj++){
                 tabAdj[numeroMax].insert(*ptAdj);
                }
            
            //tab[nRegSupress]=0
            //Mise  jour des surfaces
            tab[numeroMax].SetSurface
                (tab[nRegSupress].GetSurface()+tab[numeroMax].GetSurface());
            tab[nRegSupress].SetSurface(0);
            //modification table d'equivalence
            pImag->GetTabEquiv(nRegSupress)=numeroMax;
             
		//fin boucle de fusion
		cout << "surface region:"<< numeroMax<<" s:"<<tab[numeroMax].GetSurface()<<endl;
		}//fin if (numeroMax)
	}//fin boucle de fusion
	pImag->SetNRegFus(pImag->GetNReg()-nbfus);
	return nbfus;

}

void TabReg::affAdj(ostream& aff){
    //vector<SET_INT>::iterator ptReg;
	SET_INT::iterator ptAdj;
    //int i=1;
    for (int i=1;i<=pImag->GetNReg();i++)
    //autre ecriture possible
    //for (ptReg=tabAdj.begin();ptReg!=tabAdj.end();ptReg++)
        {
        
		aff<<"region["<<i<<"]->";
        if (tab[i].GetSurface()!=0){
            for (ptAdj=tabAdj[i].begin();ptAdj!=tabAdj[i].end();ptAdj++)
            //autre ecriture possible
		    //for (ptAdj=ptReg->begin();ptAdj!=ptReg->end();ptAdj++)
            {
			aff<<*ptAdj<<",";
		    }
        }//fin if
        aff<<endl;
    }
  }

#endif
