//conteneur.h
#if !defined(_CONTENEUR_T_H)
#define _CONTENEUR_T_H
#include<iostream>
#include<limits>
#include<algorithm>
#include<list>
using namespace std;
//debut namespace
namespace contener {

template<class T>
class conteneur {
protected : 
	int nb_el;
	int nb_max;
//VARIABLE DE CLASSE
	static std::list<conteneur<T>* > Cliste;
	// a ne pas faire, construction infinie : static Cliste<conteneur<T>* >* _Cliste;
public :
	conteneur(int max, int n);
	virtual ~conteneur();
//METHODES
	int taille_max() const { return nb_max; }
	int taille() const { return nb_el; }
	static void affiche_tous_les_conteneurs(std::ostream& f=std::cout);
	void affiche(std::ostream&) const;
	bool est_vide() const;
	bool est_plein() const;
	T& premier();
	T& dernier();
	const T& premier() const;
	const T& dernier() const;

	virtual T& element(int i)=0;
	virtual const T& element(int i) const=0;
	virtual void ajouter_en_dernier(const T& x)=0;
	virtual T retirer_dernier()=0;
};
}//fin namespace

using namespace contener;

template<class T>
std::ostream& operator<<(std::ostream& f, const contener::conteneur<T>& c);

//********************************************************************************
//********************************************************************************
//************************* IMPLEMENTATION ***************************************
//********************************************************************************
//********************************************************************************

//CREATION VARIABLE STATIQUE

template<class T> std::list<contener::conteneur<T>* > contener::conteneur<T>::Cliste;

// dclaration globale
template<class T>
std::ostream& operator<<(std::ostream& f, const contener::conteneur<T>& c){
	c.affiche(f);
	return f;
}

//Constructeur 
template<class T>
contener::conteneur<T>::conteneur(int max, int n)
:
nb_el(n),nb_max(max){
		//stockage dans la variable de classe du conteneur
		Cliste.push_back(this);
}
//Destructeur
template<class T>
contener::conteneur<T>::~conteneur(){
Cliste.remove(this);
}

template<class T>
void contener::conteneur<T>::affiche(std::ostream& f) const{
	for(int i=0; i<nb_el ; i++) f<<element(i)<<"-";
}

template<class T>
void contener::conteneur<T>::affiche_tous_les_conteneurs(std::ostream& f){
	f<<"tous les conteneurs="<<std::endl;
	typename std::list<conteneur*>::const_iterator it;
	for( it=Cliste.begin(); it!=Cliste.end(); ++it){
		f<<(*(*it))<<std::endl;
	}
}

template<class T>
bool contener::conteneur<T>::est_vide() const{ return nb_el==0; }

template<class T>
bool contener::conteneur<T>::est_plein() const{ return nb_el==nb_max; }

template<class T>
T& contener::conteneur<T>::premier() { 
	if (!est_vide()) return element(0);
	std::cerr<<"erreur tableau : demande hors limite"<<std::endl; exit(0);
}

template<class T>
T& contener::conteneur<T>::dernier(){
	if (!est_vide()) return element(nb_el-1);
	std::cerr<<"erreur tableau : demande hors limite"<<std::endl; exit(0);
}

template<class T>
const T& contener::conteneur<T>::premier()const{ 
	if (!est_vide()) return element(0);
	std::cerr<<"erreur tableau : demande hors limite"<<std::endl; exit(0);
}

template<class T>
const T& contener::conteneur<T>::dernier() const{
	if (!est_vide()) return element(nb_el-1);
	std::cerr<<"erreur tableau : demande hors limite"<<std::endl; exit(0);
}

#endif
