//date.cpp
#include "date.h"

using namespace TIME;

bool date::operator<=(const date& d) const{
		 if (annee<d.annee) return true;
		 if (annee>d.annee) return false;
		 if (mois<d.mois) return true;
		 if (mois>d.mois) return false;
		 if (jour<d.jour) return true;
		 if (jour>d.jour) return false;
		 return true;
}

bool TIME::date::operator<(const date& d) const{
		 if (annee<d.annee) return true;
		 if (annee>d.annee) return false;
		 if (mois<d.mois) return true;
		 if (mois>d.mois) return false;
		 if (jour<d.jour) return true;
		 if (jour>d.jour) return false;
		 return false;
}

bool TIME::date::operator==(const date& d) const{
		 if (annee!=d.annee) return false;
		 if (mois!=d.mois) return false;
		 if (jour!=d.jour) return false;
		 return true;
}
/*
TIME::date TIME::date::operator+(int nb_jours) const{
		 date d(*this);
		 d.jour+=nb_jours;
		 switch(d.mois){
		 case 1:
		 case 3:
		 case 5:
		 case 7:
		 case 8:
		 case 10:
		 case 12: if (d.jour>31) d.jour-=31; d.mois++; break;
		 case 4:
		 case 6:
		 case 9:
		 case 11: if (d.jour>30) d.jour-=30; d.mois++; break;
		 case 2: if (d.jour>29) d.jour-=29; d.mois++; break;
		 }
		 if (d.mois>12) {d.mois=1; d.annee++; }

		 return d;
}
*/

TIME::date TIME::date::operator+(int nb_jours) const {
	date d(jour,mois,annee);
	if (nb_jours> (duree_mois(d.mois)-d.jour)){
		nb_jours-=(duree_mois(d.mois)-d.jour+1);
		d.jour=1;
		
		if ((d.mois++)>12){
			d.mois%=12;
			d.annee++;
			
		}
		
		while (nb_jours>= duree_mois(d.mois)){
			nb_jours-=duree_mois(d.mois++)-d.jour+1;
			if ((d.mois)>12){
				d.mois%=12;
				d.annee++;
			}
		}
	}
	d.jour=d.jour + nb_jours;
	return d;
	}



	int TIME::date::duree_mois(int m) const{
		switch( m ){
		 case 1:
		 case 3:
		 case 5:
		 case 7:
		 case 8:
		 case 10:
		 case 12: return 31; 
		 case 4:
		 case 6:
		 case 9:
		 case 11: return 30;
		 case 2:  return 28;
		}
	}

		

bool TIME::horaire::operator<=(const horaire& h) const{
		 if (heure<h.heure) return true;
		 if (heure>h.heure) return false;
		 if (minute<h.minute) return true;
		 if (minute>h.minute) return false;
		 return true;
}

bool TIME::evenement::operator<=(const evenement& e) const{
		 return _date<=e._date;
}


void TIME::Agenda::operator+=(TIME::evenement& e){
		 //std::cout<<"ajout d'un evenement"<<std::endl;
		 //std::cout<<e<<std::endl;
		 if (nb_evenements<=nb_max_evenements){
		 		 int i=nb_evenements-1;
		 		 while( i>=0 && e<=(*tab[i]) ) { tab[i+1]=tab[i]; i--; }
		 		 tab[i+1]=&e;
		 		 nb_evenements++;
		 }
		 else std::cerr<<"erreur agenda :: aucun emplacement libre"<<std::endl;
}

void TIME::Agenda::affiche(std::ostream& f) const{
		 f<<"#####    AGENDA  #####"<<std::endl;
		 for(int i=0; i<nb_evenements; i++) f<<"n:"<<i<<":"<<*tab[i]<<std::endl;
		 f<<"##### FIN AGENDA #####"<<std::endl;
}

TIME::Agenda::~Agenda(){
	
	for (int i=0;i<nb_evenements;i++){
		std::cout<<"n:"<<i<<"detruit";
			tab[i]->affiche();
			delete tab[i];
	}
		 
	delete [] tab;
}

std::ostream& operator<<(std::ostream& f, const TIME::date & d){
		 d.affiche(f); return f;
}

std::ostream& operator<<(std::ostream& f, const TIME::duree & d){
		 d.affiche(f); return f;
}

std::ostream& operator<<(std::ostream& f, const TIME::horaire & h){
		 h.affiche(f); return f;
}

std::ostream& operator<<(std::ostream& f, const TIME::evenement& e){
		 e.affiche(f); return f;
}

std::ostream& operator<<(std::ostream& f, const TIME::Agenda& e){
		 e.affiche(f); return f;
}

//fin date.cpp
