   //date.h
   #include <iostream>
   #include <string>
   #ifndef DATE_
   #define DATE_
   
   namespace TIME{
   
   class date{
     protected:
   			 int jour;
   			 int mois;
   			 int annee;
   	 public:
   			 date(int j, int m, int a): jour(j), mois(m), annee(a) 
   				{}
   			 void set_date(int j, int m, int a) 
   				{ jour=j; mois=m; annee=a; }
   			 void affiche(std::ostream& f=std::cout) const 
   				{ f<<jour<<"/"<<mois<<"/"<<annee; }
   			 bool operator<=(const date& d) const; 
   			 bool operator<(const date& d) const;
   			 bool operator==(const date& d) const; 
   			 date operator+(int nb_jours) const ;
	 private:
		 int duree_mois(int m) const;
   	 };
   
   class duree{
   	 protected:
   			 int nb_minutes;
   	 public:
   			 duree(int heures, int minutes):nb_minutes(heures*60+minutes)
   				{}
   			 void set_duree(int heures, int minutes) 
   				{ nb_minutes=heures*60+minutes; }
   			 int get_duree_minutes() const 
   				{ return nb_minutes; }
   			 double get_duree_heures() const 
   				{ return double(nb_minutes)/60; }
   			 void affiche(std::ostream& f=std::cout) const 
   				{ f<<nb_minutes/60<<"h"<<nb_minutes%60; }
   	 };
   
   class horaire{
       protected:
   			 int heure;
   			 int minute;
   	 public:
   			 horaire(int h, int m):heure(h),minute(m) 
   				{}
   			 void set_horaire(int h, int m) { heure=h; minute=m; }
   			 void affiche(std::ostream& f=std::cout) const 
   				{ f<<heure<<"h"<<minute; }
   			 int get_heure() const { return heure; }
   			 int get_minute() const { return minute; }
   			 bool operator<=(const horaire& h) const;
   	 };
   
   //CLASSE ABSTRAITE
   class evenement {
   	 protected:
   			 std::string _objet;
   			 date _date;
   	 public:		 
   			 // editer l'vnement
   			 virtual void edition()=0;
   			 // afficher l'vnement
   			 virtual void affiche(std::ostream& f=std::cout) const=0;
   			 evenement(int j, int m, int a, const char* obj)
   			:
   			_date(j,m,a),_objet(obj)
   		{}
   			 virtual ~evenement() 
   			{}
   			 virtual bool operator<=(const evenement& e) const;
   	 };
   
   class Agenda {
   			 evenement** tab;
   			 int nb_evenements;
   			 int nb_max_evenements;
   	 public:
   			 Agenda(int max):
   					 nb_evenements(0),
   					 nb_max_evenements(max),
   					 tab(new evenement* [max]) 
   					{}
   			 ~Agenda();
   			 void operator+=(evenement& e);
   			 void affiche(std::ostream& f=std::cout) const;
   	 };
   /*
   std::ostream& operator<<(std::ostream& f, const TIME::date & d);
   std::ostream& operator<<(std::ostream& f, const TIME::duree & d);
   std::ostream& operator<<(std::ostream& f, const TIME::horaire & h);
   std::ostream& operator<<(std::ostream& f, const TIME::evenement& e);
   std::ostream& operator<<(std::ostream& f, const TIME::Agenda& e);
   */
   
   
   
   }//fin namespace TIME
   
   
   std::ostream& operator<<(std::ostream& f, const TIME::date & d);
   std::ostream& operator<<(std::ostream& f, const TIME::duree & d);
   std::ostream& operator<<(std::ostream& f, const TIME::horaire & h);
   std::ostream& operator<<(std::ostream& f, const TIME::evenement& e);
   std::ostream& operator<<(std::ostream& f, const TIME::Agenda& e);
   
   
   #endif

