   //dateHerit.h
   #include <iostream>
   #include <string>
   #ifndef DATEHERIT_
   #define DATEHERIT_
   #include "date.h"
   namespace TIME{
   //using namespace std;
   		 class evenement_1_jour : public evenement {
   		 public:
   		 		 void edition();
   		 		 void affiche(std::ostream& f=std::cout) const;
   		 		 evenement_1_jour(int j, int m, int a, const char* obj)
  				:
                 		evenement(j,m,a,obj)
                   	{}
   		 };
   
   		 class evenement_1_jour_avec_duree : public evenement_1_jour {
   		 protected:
   		 		 horaire _debut;
   		 		 duree   _duree;
   		 public:
   		 		 void edition();
   		 		 void affiche(std::ostream& f=std::cout) const;
   		 		 evenement_1_jour_avec_duree(int j, int m, int a, const char* obj, 
   								int hdebut, int mdebut, int hdur, int mdur)
           						:
   		 		 		 		 evenement_1_jour(j,m,a,obj),
   		 		 		 		 _debut(hdebut,mdebut),
   		 		 		 		 _duree(hdur,mdur)
               					{}
   		 		 horaire get_horaire_fin() const;
   		 		 bool operator<=(const evenement_1_jour_avec_duree& e) const;
   		 };
   
   		 class evenement_plusieurs_jours : public evenement {
   		 		 int nb_jours;
   		 public:
   		 		 void edition();
   		 		 void affiche(std::ostream& f=std::cout) const;
   		 		 evenement_plusieurs_jours(int j, int m, int a, const char* obj, int nbj)
         				:
                 		evenement(j,m,a,obj),nb_jours(nbj)
                   	{}
   		 		 date get_date_fin() const;
   		 };
   
   		 class rendez_vous : public evenement_1_jour_avec_duree {
   		 protected:
   		 		 std::string personne;
   		 		 std::string lieu;
   		 public:
   		 		 void edition();
   		 		 void affiche(std::ostream& f=std::cout) const;
   		 		 rendez_vous(int j, int m, int a, const char* obj, 
   		 		 		 		 		 int hdebut, int mdebut, int hdur, int mdur,
   		 		 		 		 		 const char* p,
   		 		 		 		 		 const char* l)
      			:
   		 		 		 evenement_1_jour_avec_duree(j,m,a,obj,hdebut,mdebut,hdur,mdur),
   		 		 		 personne(p),
   		 		 		 lieu(l)
            				{}
   		 };
   
   }//fin namespace
   
   #endif
