//fract.cpp
#include "fract_sa.h"
//dfinition de la variable de classe
int fraction::nbFraction=0;

//definition de la mthode de classe
int fraction::get_nbFraction(){
	return nbFraction;
}

//constructeurs
//fraction::fraction():num(0),denom(1){}

fraction::fraction(int n, int d):num(n),denom(d){
simplification();
nbFraction++;
                       }

//accesseurs
int fraction::lire_num()const {
return(num);
}
int fraction::lire_denom() const{
return(denom);
}
void fraction::ecrit_num(int n){
	num=n;
}
void fraction::ecrit_denom(int d){
	denom=d;
}
//mthodes


void fraction::simplification(){
		int p=pgcd(num,denom);
    num/=p;
	denom/=p;
}


/*
fraction& fraction::operator =(int const i){
    num=i;
    denom=1;
	return *this;
    }  
*/
//retour par reference possible
fraction & fraction::operator ++(){
    num=num+denom;
    simplification();
    return (*this);
    }
 //retour par reference impossible  
fraction  fraction::operator ++(int ){
    fraction temp=*this;
    num=num+denom;
    simplification();
    return (temp);
    }
    
//retour par reference impossible sur r
fraction fraction::operator +(fraction const &f){
	fraction r(num*f.denom+denom*f.num,denom*f.denom);
	simplification();
	return(r);
}

fraction fraction::operator -(fraction const &f){
	fraction r(num*f.denom-denom*f.num,denom*f.denom);
	simplification();
	return(r);
}

fraction &  fraction::operator += (fraction const &f){
	num=num*f.denom-denom*f.num;
	denom=denom*f.denom;
	simplification();
	return *this;
}

bool fraction::operator <(fraction const & f){
	int p=pgcd(denom,f.denom);
	return(num*p <f.num*p);
}

//mthode static
/*
int fraction::pgcd(int u,int v){
    u<0?u=-u:1;
    v<0?v=-v:1;
	while(u!=v)
	if (u>v) u=u-v;
		else v=v-u;
	return (u);
}
*/
//algorithme d'euclide
int fraction::pgcd(int u,int v){
    u<0?u=-u:1;
    v<0?v=-v:1;
	if (v==0) return u;
	else return pgcd (v,u%v);    
}

//fonctions ordinaires dfinie globalement
ostream & operator << (ostream & os, fraction const& f){
	return
        os << f.lire_num() 
        << "/ " << f.lire_denom() 
        <<endl;
	return os;
}

/*
istream& operator>>(istream& flot, fraction& f){
	int n,d;
	flot>>n;
	if (flot) while (flot.peek()==' ') flot.ignore(); // passe les espaces
	if(flot && flot.peek()=='/') {
		flot.ignore();
		flot>>d; 
	}
	else {
		d=1;
	}
	f=fraction(n,d);
	return flot;
}
*/

/*
istream& operator>>(istream& flot, fraction& f){
	int n,d;
	flot>>n>>ws;
	if (flot) while (flot.peek()=='/'){
		flot.ignore();
		flot>>d; 
	}
	else {
		d=1;
	}
	f=fraction(n,d);
	return flot;
}
*/

istream& operator>>(istream& flot, fraction& f){
	int n,d;
	char c;
	//ws: Extracts leading white space from the stream by calling the eatwhite function.
	//cherche le premier entier
	flot>>ws>>n;
	//p 146 
	if(!flot.eof()){
        c=flot.peek();                
		if (c=='/') {flot.ignore(); flot>>d;} //ignore et extrait /
		else {
             if(c=='\n') d=1;
             else {cout<<"erreur de format\n";d=1;}
             }
	}
	f=fraction(n,d);
	return flot;
}


/*
surcharge d'oprateur
dfinition globale
syntaxe diffrente de la dfinition comme oprateur membre
*/
// les accesseurs sont inutiles ci_dessous si friend
fraction operator * (fraction const &f1, fraction const &f2 ){
    fraction f(f1.num*f2.num,f1.denom*f2.denom);
    f.simplification();
    return f;
    }
//cette fonction permet l'opration f=2+f1 si le constructeur 
//n'est pas dclarer explicit  
fraction operator + (fraction const & f1, fraction const & f2 ){
    fraction r(f1.num*f2.denom+f1.denom*f2.num,f1.denom*f2.denom);
    r.simplification();
    return r;
    }
    
bool operator==(const fraction &f1, const fraction &f2){
	return (f1.denom==f2.denom && f1.num==f2.num);
}


