//liste.h
#ifndef LISTE_H
#define LISTE_H
#include "cellule.h"

#include "conteneur.h"
//liste problme
namespace contener{
//template<class T> class conteneur;
template<class T> class liste: public conteneur<T> {
	cellule<T>* tete;
public:
	liste(int taille_max=std::numeric_limits<int>::max(), int taille=0, const T& initialize_with=0);
	liste(const liste&);
	~liste();
	liste& operator=(const liste& t);
	T& element(int i);
	const T& element(int i) const;
	void ajouter_en_dernier(const T& x);
	T retirer_dernier();
	void retirer(const T& x);
};


//using namespace contener;
template<class T>
contener::liste<T>::liste(int taille_max, int taille, const T& initialize_with)
:
conteneur<T>(taille_max,taille),tete(0){
	int n=0;
	cellule<T>* prec=0;
	while(n<nb_el){
		cellule<T>* tmp=new cellule<T>;
		tmp->cle=initialize_with;
		if (prec) prec->succ=tmp; else tete=tmp;
		prec=tmp;
		n++;
	}
}

template<class T>
contener::liste<T>::liste(const contener::liste<T>& l)
:
conteneur(l.nb_max,l.nb_el),tete(0){
	cellule<T>* prec=0;
	cellule<T>* ppt=l.tete;
	while(ppt!=0){
		cellule* tmp=new cellule<T>;
		tmp->cle=ppt->cle;
		if (prec) prec->succ=tmp; else tete=tmp;
		prec=tmp;
		ppt=ppt->succ;
	}
}

template<class T>
contener::liste<T>::~liste(){
	while(tete!=0){
		cellule<T>* tmp=tete;
		tete=tete->succ;
		delete tmp;
	}
}

template<class T>
contener::liste<T>& contener::liste<T>::operator=(const contener::liste<T>& l){
	if (this!=&l){
		nb_max=l.nb_max;
		nb_el=l.nb_el;
		cellule<T>* prec=0;
		cellule<T>* ppt=l.tete;
		while(ppt!=0){
			cellule<T>* tmp=new cellule<T>;
			tmp->cle=ppt->cle;
			if (prec) prec->succ=tmp; else tete=tmp;
			prec=tmp;
			ppt=ppt->succ;
		}
	}
	return *this;
}

template<class T>
T& contener::liste<T>::element(int i){
	if (i>nb_el || i<0) { std::cerr<<"erreur liste : demande hors limite"<<std::endl; exit(0); }
	int n=nb_el-i-1;
	cellule<T>* ppt=tete;
	while(n>0) { ppt=ppt->succ; n--; }
	return ppt->cle;
}

template<class T>
const T& contener::liste<T>::element(int i) const{
	if (i>nb_el || i<0) { std::cerr<<"erreur liste : demande hors limite"<<std::endl; exit(0); }
	int n=nb_el-i-1;
	cellule<T>* ppt=tete;
	while(n>0) { ppt=ppt->succ; n--; }
	return ppt->cle;
}

template<class T>
void contener::liste<T>::ajouter_en_dernier(const T& x){
	if (!est_plein()){
		cellule<T>* tmp=new cellule<T>;
		tmp->cle=x;
		tmp->succ=tete;
		tete=tmp;
		nb_el++;
	}else std::cerr<<"erreur liste :: liste pleine"<<std::endl;
}


template<class T>
T contener::liste<T>::retirer_dernier(){
	if (!est_vide()){
		T ret_tmp=tete->cle;
		cellule<T>* tmp=tete;
		tete=tete->succ;
		delete tmp;
		nb_el--;
		return ret_tmp;
	}else std::cerr<<"erreur liste :: liste vide"<<std::endl;
	return 0;
}


template<class T>
void contener::liste<T>::retirer(const T& x){
	cellule<T>* prec=0;
	cellule<T>* pt=tete;
	while(pt!=0){ 
		if (pt->cle==x){
			if (prec!=0) prec->succ=pt->succ;
			else tete=pt->succ;
			cellule<T>* tmp=pt;
			pt=pt->succ;
			delete tmp;
		}else pt=pt->succ;
	}
}	
}//fin namespace
#endif
