// pile0.cpp: implementation de la classe pile.

//

//////////////////////////////////////////////////////////////////////



#include "pile0.h"

using namespace std;

//////////////////////////////////////////////////////////////////////

// Construction/Destruction

//////////////////////////////////////////////////////////////////////


pile::pile(const unsigned int n){
	tete=-1;
	nb_max=n;
	tab=new Personne[n];
}

pile::~pile(){
	tete=-1;
	nb_max=0;
	if (tab!=0) delete[] tab;
}
// constructeur de copie ... trs important !!!
pile::pile(const pile& p):tete(p.tete),nb_max(p.nb_max){

	tab=new Personne[nb_max];

	for(int i=0; i<=tete; i++) tab[i]=p.tab[i];
}
// oprateur d'affectation ... trs important !!!
pile& pile::operator=(const pile& p){
	if (this!=&p){
		if (tab!=0) delete[] tab;
		nb_max=p.nb_max;
		tete=p.tete;
		tab=new Personne[nb_max];
		for(int i=0; i<=tete; i++) tab[i]=p.tab[i];
	}
	return *this;
}

//////////////////////////////////////////////////////////////////////

// outils

//////////////////////////////////////////////////////////////////////

inline bool pile::est_vide(){ return (tete==-1); }
inline bool pile::est_pleine(){ return (tete+1>=nb_max); }

void pile::empiler(Personne & p){
	if (!est_pleine()) tab[++tete]=p;
	else cerr <<"pile pleine : ne peut empiler l'element "<< p <<"."<<endl;
}

Personne   pile::depiler(){
	if (!est_vide()){
		return tab[tete--];;
	}
	cerr<<"pile vide : aucun element a depiler."<<endl;
	return Personne();
}
Personne pile::lire_dernier(){
	if (!est_vide()){
		return tab[tete];
	}
	cerr<<"pile vide : aucun element a lire."<<endl;
	return Personne();
}
void pile::vider(){
	tete=-1;
}

void pile::affiche(ostream& flux) const{
	for(int i=0; i<=tete; i++){
		flux<<"tab["<<i<<"]=\n"<<tab[i];
	}
	flux<<endl;
}

pile pile::operator+(const pile& p2){
	pile p(nb_max+p2.nb_max);
	int i;
	p.tete=-1;
	for(i=0; i<=tete ; i++) { p.tete++; p.tab[p.tete]=tab[i];  } 
	for(i=0; i<=p2.tete ; i++) { p.tete++; p.tab[p.tete]=p2.tab[i];  }
	return p;
} 

//////////////////////////////////////////////////////////////////////

// fonctions assistantes

//////////////////////////////////////////////////////////////////////



ostream& operator<<(ostream& flux, pile& p){
	p.affiche(flux);
	return flux;
}





