
//textEditorApp4.cpp

#include "wx/wx.h"

#include "TextEditorApp4.h"

IMPLEMENT_APP(TextEditorApp)

/*
 dfinition du constructeur TextFrame
*/

TextFrame::TextFrame(const wxChar *title, int xpos, int ypos, int width, int height)
: wxFrame((wxFrame *) NULL, -1, title, wxPoint(xpos, ypos), wxSize(width, height))
{

//creation de l'objet de gestion de texte wxTextCtrl
m_pTextCtrl = new wxTextCtrl(this, -1, wxString("Entrer un texte..."),
wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE);


CreateStatusBar();
m_pMenuBar = new wxMenuBar();
// File Menu
m_pFileMenu = new wxMenu();
m_pFileMenu->Append(MENU_FILE_OPEN, "&Ouvrir", "Ouvre un fichier existant");
m_pFileMenu->Append(MENU_FILE_SAVE, "&Sauver", "Sauvegarde le fichier");
m_pFileMenu->AppendSeparator();
m_pFileMenu->Append(MENU_FILE_QUIT, "&Quitter", "Ferme l'application");
m_pMenuBar->Append(m_pFileMenu, "&Fichier");
// About menu
m_pInfoMenu = new wxMenu();
m_pInfoMenu->Append(MENU_INFO_ABOUT, "&Apropos", "Informations a propos de l'application");
m_pMenuBar->Append(m_pInfoMenu, "&Information");

SetMenuBar(m_pMenuBar);

}

TextFrame::~TextFrame()
{
}

bool TextEditorApp::OnInit()
{
TextFrame *frame = new TextFrame("Simple Editeur de Texte", 100, 100, 400, 300);
frame->Show(TRUE);
SetTopWindow(frame);
return true;
}

BEGIN_EVENT_TABLE(TextFrame, wxFrame)
EVT_MENU(MENU_FILE_OPEN, TextFrame::OnMenuFileOpen)
EVT_MENU(MENU_FILE_SAVE, TextFrame::OnMenuFileSave)
EVT_MENU(MENU_FILE_QUIT, TextFrame::OnMenuFileQuit)
EVT_MENU(MENU_INFO_ABOUT, TextFrame::OnMenuInfoAbout)

END_EVENT_TABLE()

//fonctions associes aux items du menu

void TextFrame::OnMenuFileOpen(wxCommandEvent &event)
{
wxFileDialog *dlg = new wxFileDialog(this, "Ouvrir un fichier texte",
"", "", "All files(*.*)|*.*|Text Files(*.txt)|*.txt",
wxOPEN, wxDefaultPosition);

if ( dlg->ShowModal() == wxID_OK )
	{
	//m_pTextCtrl->LoadFile(dlg->GetFilename());
	m_pTextCtrl->LoadFile(dlg->GetPath());
	//SetStatusText(dlg->GetFilename(), 0);
	SetStatusText(dlg->GetPath(), 0);
	}
dlg->Destroy();
}

void TextFrame::OnMenuFileSave(wxCommandEvent &event)
{
wxFileDialog *dlg = new wxFileDialog(this, "Sauver un fichier texte",
"", "", "All files(*.*)|*.*|Text Files(*.txt)|*.txt",
wxSAVE, wxDefaultPosition);

if ( dlg->ShowModal() == wxID_OK )
	{
	m_pTextCtrl->SaveFile(dlg->GetPath());
	SetStatusText(dlg->GetPath(), 0);
	}
dlg->Destroy();
}

void TextFrame::OnMenuFileQuit(wxCommandEvent &event)
{
Close(FALSE);
}

void TextFrame::OnMenuInfoAbout(wxCommandEvent &event)
{
wxLogMessage("Item A propos fichier selectionn");
}





