//tableau.h
#ifndef TABLEAU_H
#define TABLEAU_H

#include "conteneur.h"

namespace contener{
template<class T> class tableau : public conteneur<T> {
	T* tab;
public:
	tableau(int taille_max, int taille, const T& initialize_with=T());
	tableau(const tableau<T>&);
	~tableau();
	tableau<T>& operator=(const tableau<T>& t);
	T& element(int i);
	const T& element(int i) const;
	T& operator[](int i);
	const T& operator[](int i) const;
	void ajouter_en_dernier(const T& x);
	T retirer_dernier();
};

}//fin namespace conteneur

using namespace contener;

template<class T>
contener::tableau<T>::tableau(int taille_max, int taille, const T& initialize_with)
:
conteneur<T>(taille_max,taille),tab(new T[taille]){
	for(int i=0; i<nb_el; i++) tab[i]=initialize_with;	
}

template<class T>
contener::tableau<T>::tableau(const contener::tableau<T>& t)
:
conteneur<T>(t.nb_max,t.nb_el),tab(new T[nb_max]){
	for(int i=0; i<nb_el; i++) tab[i]=t.tab[i];	
}

template<class T>
contener::tableau<T>::~tableau(){
	delete[] tab;
}

template<class T>
T& contener::tableau<T>::operator[](int i){
	if (i<nb_el && i>=0) return tab[i];
	std::cerr<<"erreur tableau : demande hors limite"<<std::endl; exit(0);
}

template<class T>
const T& contener::tableau<T>::operator[](int i) const{
	if (i<nb_el && i>=0) return tab[i];
	std::cerr<<"erreur tableau : demande hors limite"<<std::endl; exit(0);
}

template<class T>
T& contener::tableau<T>::element(int i){
	if (i<nb_el && i>=0) return tab[i];
	std::cerr<<"erreur tableau : demande hors limite"<<std::endl; exit(0);
}

template<class T>
const T& contener::tableau<T>::element(int i) const{
	if (i<nb_el && i>=0) return tab[i];
	std::cerr<<"erreur tableau : demande hors limite"<<std::endl; exit(0);
}

template<class T>
contener::tableau<T>& contener::tableau<T>::operator=(const contener::tableau<T>& t){
	if (this!=&t){
		delete[] tab;
		nb_max=t.nb_max;		
		nb_el=t.nb_el;
		tab=new T[nb_max];
		for(int i=0; i<nb_el; i++) tab[i]=t.tab[i];	
	}
	return *this;
}

template<class T>
void contener::tableau<T>::ajouter_en_dernier(const T& x){
	if (!est_plein()){
		tab[nb_el]=x;
		nb_el++;
	}else std::cerr<<"erreur tableau :: tableau plein"<<std::endl;
}

template<class T>
T contener::tableau<T>::retirer_dernier(){
	if (!est_vide()){
		nb_el--;
		return tab[nb_el];
	}
	std::cerr<<"erreur tableau :: tableau vide"<<std::endl;
	return 0;
}

#endif
