//vecteur.h

#include "tous.h"
using namespace std;

template <class It, typename T > class inv_iterateurC;

template <typename T, class A=allocator<T> > class Vecteur{
	public:
		typedef typename A::pointer iterateur;
		typedef inv_iterateurC< typename A::pointer, T> inv_iterateur;
		
   

	private:
		A alloc;
		iterateur debut;//premier element
		iterateur fin;  // juste aprs le dernier element prsent
		iterateur max;  // pointe aprs la dernire place alloue a Vecteur
		int nb_element; // nombre element contenu
		int capac;		//capacit du vecteur;

//CONSTRUCTEUR
	public:
         explicit Vecteur(int n, const T& val=T(), const A& a=A())
			 :alloc(a),nb_element(0),capac(n){
			 debut=alloc.allocate(n,0);
			 max=debut+n;
			 for (iterateur p=debut;p<max;++p) alloc.construct(p,val);
			 fin=debut;
		 }

//DESTRUCTEUR

//SURCHARGE oprateur []            
            T& operator[](unsigned index);
            //Vecteur(unsigned n);

//METHODES
			iterateur begin()const {return debut;}
			iterateur  end() const {return fin;}
			iterateur  maxi() const {return max;}

			inv_iterateur rbegin()const {return (inv_iterateur)(fin-1);}
			inv_iterateur  rend() const {return (inv_iterateur)(debut-1);}



			int size(){return nb_element;}
			bool empty(){return (nb_element==0);}
			int capacity(){return capac;}
            int  size() const {return nb_element;}
//ajoute en fin
		void push_back(const T & V)
			{
				if (fin >= max){
					resize(3+capacity());
				}
					alloc.construct(fin++,V);
					nb_element++;
			}

		void pop_back(){
			if (size()==0);
			else{
				nb_element--;
				alloc.destroy(fin);
				fin--;
			}
			return;
		}

		void resize(int n, T x = T()){
			if (size()>=n) return;
			else
			{
				reserve(n);
				iterateur q=fin;
				while(q<maxi())
					alloc.construct(q++,x);	
			}
		}

		void reserve(int n){
				if (n<= capacity()) return;
				iterateur p=alloc.allocate(n,0);
				iterateur q=debut;
				while(q<debut+size()){
					alloc.construct(p++,*q);
					alloc.destroy(q++);
				}
				alloc.deallocate(debut,capacity());
				debut=p-size();
				max=debut+n;
				fin=debut+nb_element;
				capac=n;
			}
//void affiche ( ostream& );

void affiche ( ostream& o){
				if (empty()==false)
				for (iterateur p=begin();p<max;p++)
					o<<(*p);
				else o<<"liste vide"<<endl;
				}  

friend ostream& operator <<( ostream& o, Vecteur<T>& V);

    };

template <class T> ostream& operator  << ( ostream& o,   Vecteur<T>& V){
				if (V.empty()==false)
				for (typename Vecteur<T>::iterateur p=V.begin();p<V.end();p++)
					o<<((T) (*p));
				else o<<"liste vide"<<endl;
				return o;
				}   
/*
template <class T> void Vecteur<T>::affiche ( ostream& o ){
				if (empty()==false)
				for (iterateur p=begin();p<max;p++)
					o<<(*p);
				else o<<"liste vide"<<endl;
				}  
  
*/
template <class It, typename T > class inv_iterateurC{
	It current;
	public:
	inv_iterateurC(It x=0):current(x){}

	inv_iterateurC operator++(){
		current--;
		return *this;
	}
	T& operator*() const{return *current;}

	bool operator>(inv_iterateurC q) const {return(current> q.current);}
	bool operator<(inv_iterateurC q) const {return(current< q.current);}

};

